--独家企划特权购买窗口
Lua_EspecialPlanBuyWindow = class("Lua_EspecialPlanBuyWindow", Lua_Window);
function Lua_EspecialPlanBuyWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;
	self.windowName = "Lua_EspecialPlanBuyWindow";
	self.skinName = "EspecialPlanBuyWindow_skin";
end

function Lua_EspecialPlanBuyWindow:buildShowItem()
	self:superCall("buildShowItem");
    
    self.downDragList = Lua_DragList.new(self.content, 500, 100, Lua_AxisDefine.Horizontal);
    self.downDragList:setListCell(Lua_EspecialPlanIconItem, 100, 100, 1);
    self.downDragList:setCellSpacing(4, 0);
    self.downDragList:setLocation(0, -88);

    self.topDragList = Lua_DragList.new(self.content, 500, 100, Lua_AxisDefine.Horizontal);
    self.topDragList:setListCell(Lua_EspecialPlanIconItem, 100, 100, 1);
    self.topDragList:setCellSpacing(4, 0);
    self.topDragList:setLocation(0, 96);

	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
	self:showWinInfo();
end

function Lua_EspecialPlanBuyWindow:showWinInfo()
	self.buyTipsTxt:setLangValue(450014);
	local rechargeId = DataCenter.exclusivePlanUtil.rechargeId;
	self.rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
	self.buyBtn.label = LanUtil.formateStr(450018, self.rechargeInfo.money);
    
    self:showTopItem();
    self:showDownItem();
end

function Lua_EspecialPlanBuyWindow:showTopItem()
	local arr = Array();
	local maxLevel = DataCenter.exclusivePlanData.stateList and #DataCenter.exclusivePlanData.stateList or nil;
    local planLevel = DataCenter.exclusivePlanData.planLevel;

    if maxLevel == nil or planLevel == nil then
    	return;
    end

    local generalRewardArr;
    local overLevel = planLevel + 10 > maxLevel and maxLevel or planLevel + 10;
	if planLevel + 1 <= maxLevel then
		generalRewardArr = DataCenter.exclusivePlanUtil:getTwoLevelReward(planLevel + 1, overLevel, false, true);
	end
	local seniorRewardArr = DataCenter.exclusivePlanUtil:getTwoLevelReward(1, overLevel, true, false);
	if generalRewardArr ~= nil then
		for i = 1, generalRewardArr:getSize() do
			arr:add(generalRewardArr[i]);
		end
	end
	if seniorRewardArr ~= nil then
		for i = 1, seniorRewardArr:getSize() do
			arr:add(seniorRewardArr[i]);
		end
	end
    
    local width;
	local list = DataCenter.exclusivePlanUtil:mergeRewardInfo(arr);
	if #list <= 4 then
    	width = 100 * #list + 4 * (#list - 1);
    	self.topDragList.canDrag = false;
    else
    	width = 450;
		self.topDragList.canDrag = true;
	end
	self.topDragList:setContentRect(width, 100);
	self.topDragList:setArrayData(list);
end

function Lua_EspecialPlanBuyWindow:showDownItem()
	local maxLevel = DataCenter.exclusivePlanData.stateList and #DataCenter.exclusivePlanData.stateList or nil;

	if maxLevel == nil then
		return;
	end
    
    local width;
	local arr = DataCenter.exclusivePlanUtil:getTwoLevelReward(1, maxLevel, true, false);
	local list = DataCenter.exclusivePlanUtil:mergeRewardInfo(arr);
	if #list <= 4 then
    	width = 100 * #list + 4 * (#list - 1);
    	self.downDragList.canDrag = false;
    else
    	width = 450;
		self.downDragList.canDrag = true;
	end
	self.downDragList:setContentRect(width, 100);
	self.downDragList:setArrayData(list);
end


function Lua_EspecialPlanBuyWindow:onBuyBtnClick()
	if self.rechargeInfo == nil then
		return;
    end
    DataCenter.sdkInterface:PointOut(1, tonumber(self.rechargeInfo.money), tonumber(self.rechargeInfo.money_type),
            tonumber(self.rechargeInfo.id), self.rechargeInfo.gift_name, self.rechargeInfo.gold);
    self:hide();
end

function Lua_EspecialPlanBuyWindow:dispose()
	if self.downDragList ~= nil then
		self.downDragList:dispose();
		self.downDragList = nil;
	end
	if self.topDragList ~= nil then
		self.topDragList:dispose();
		self.topDragList = nil;
	end

	self:superCall("dispose");
end









Lua_EspecialPlanIconItem = class("Lua_EspecialPlanIconItem", Lua_ItemIconCell)
function Lua_EspecialPlanIconItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_EspecialPlanIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.8, 0.8)
end

function Lua_EspecialPlanIconItem:onMouseDownHandle()
	self.itemIcon:setScale(0.76, 0.76)
end

function Lua_EspecialPlanIconItem:onMouseUpHandle()
	self.itemIcon:setScale(0.8, 0.8)
end