--独家企划主界面
checkRequire("Lua_RoundList")
Lua_ExclusivePlanPanel = class("Lua_ExclusivePlanPanel", Lua_DisplayObject);
function Lua_ExclusivePlanPanel:ctor(p)
	self:superCall("ctor", p, "ExclusivePlanPanel_skin");
end

function Lua_ExclusivePlanPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.roundList = Lua_RoundList.new(self.content, 620, 700, Lua_AxisDefine.Vertical);
	self.roundList:setCell(Lua_ExclusivePlanLevelItem, 380, 93);
	self.roundList:setRound(400, true, -190);
	self.roundList:setShowCount(5);
	--self.roundList.radius = 400;
	--self.roundList.needRegulate = true;
	self.roundList:setRot(0, 0, 4);
	self.roundList:setLocation(50, -25);
	self.roundList.tweenId = 2025;
	self.roundList.delayTween = true;

	-- self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	-- self.flashItem:setScale(0.48, 0.48);
	-- self.flashItem:setLocation(-183, -44);
	-- self.flashItem.canRotate = false;
	-- self.flashItem:setRot(0, 0, 4);
	--self.flashItem:setCallBack(self, self.onCardShow);

	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content);
	self.roleInfoPanel:setRectAnchor(1)

	self.bOpenUpdate = true;
	self.roundList:setSiblingIndex(10);
    
    self.levelUpBtn:addClickFuntion(self, self.onLevelUp);
    self.extraExperienceIcon:addClickFuntion(self, self.onExtraExpClick);
    self.unlockBtn:addClickFuntion(self, self.onEspecialPlanBuy);
    self.memorandumImg:addClickFuntion(self, self.onGoTask);
    self.helpIcon:addClickFuntion(self, self.onHelpClick);
    self:addLuaEvent("SHOW_PLAN_PANEL_INFO", self, self.updatePanelInfo);
    
    self:updateData();
	--self:showCardTips();
    --self:showCard();
end

function Lua_ExclusivePlanPanel:updateData()
	local endTime = DataCenter.exclusivePlanData.endTime;
	local serverTime = DataCenter.roleData.serverTime;
	if endTime ~= nil and endTime - serverTime <= 0 then
		Lua_ProxyManager.getProxy("Lua_ExclusivePlanProxy"):sExclusivePlanInfo();
	else
		self:updatePanelInfo();
	end
end

function Lua_ExclusivePlanPanel:showCard()
	local curPeriod = DataCenter.exclusivePlanData.curPeriod;
	local config = getConfig("sole_plan_type", curPeriod);

	if config ~= nil then
		local flashId = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(config.flash_id, Lua_CollectionBookUtil.FLASH_ID);
		if flashId == nil then
			return;
		end
		local flashInfo = Lua_FlashCardVo.new(flashId);
		self.flashItem:setData(flashInfo);
	end
end

function Lua_ExclusivePlanPanel:updatePanelInfo()
    local curLevel = DataCenter.exclusivePlanData.planLevel;
    local curPeriod = DataCenter.exclusivePlanData.curPeriod;

    if curLevel == nil or curPeriod == nil then
    	return;
    end
	
	self.levelTxt.text = curLevel;

	if DataCenter.exclusivePlanData.planType == 1 then
		self.unlockBtn.label = LanUtil.getValue(450021);
	else
		local rechargeId = DataCenter.exclusivePlanUtil.rechargeId;
	    local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
		self.unlockBtn.label = LanUtil.formateStr(450017, rechargeInfo.money);
	end

    local arr = DataCenter.exclusivePlanData.levelIdArr;
    if arr ~= nil then
		self.roundList:setData(arr, self.bOpenUpdate);

	    local index;
	    local vo;
		for i = arr:getSize(), 1, -1 do
			vo = DataCenter.exclusivePlanData:getLevelVoById(arr[i]);
			if vo.state == 1 or vo.seniorState == 1 then
				index = i;
			end
		end
		if index ~= nil then
			self.roundList:moveToIndex(index, self.bOpenUpdate);
			self.getAllBtn:addClickFuntion(self, self.getAllReward);
	        self.getAllBtn:setGray(false);
		else
			self.roundList:moveToIndex(arr:getSize() - curLevel, self.bOpenUpdate);
			self.getAllBtn:setGray(true);
			self.getAllBtn:removeClickFuntion(self, self.getAllReward);
		end
	end
    
    local exp = DataCenter.moneyData:getMoney(Lua_ResourcesDefine.PLAN_EXP);
    local nextVo = DataCenter.exclusivePlanData:getLevelVoById((curLevel + 1) + curPeriod * 10000);
    local curVo = DataCenter.exclusivePlanData:getLevelVoById(curLevel + curPeriod * 10000);
    if nextVo ~= nil then
	    self.experienceBar:setMaxValue(nextVo.upNeedExp);
	    self.experienceBar:setValue(exp);
	    self.experienceBar:setText(exp.."/"..nextVo.upNeedExp);
	end
	if curLevel == arr:getSize() then
		if curVo ~= nil then
			self.experienceBar:setMaxValue(curVo.upNeedExp);
		    self.experienceBar:setValue(curVo.upNeedExp);
		    self.experienceBar:setText(curVo.upNeedExp.."/"..curVo.upNeedExp);
		end
	end
    
    if DataCenter.exclusivePlanData.extraExpState == 1 then
    	if self.expRedPoint == nil then
    		self.expRedPoint = Lua_RedPointIcon.new(self.content);
			self.expRedPoint:createRedPointEff();
			self.expRedPoint:setRectAnchor(7);
			self.expRedPoint:setLocation(-263, 243, 0);
		end
		self.expRedPoint:updateRedPointShow(true);
    else
    	if self.expRedPoint ~= nil then
    		self.expRedPoint:updateRedPointShow(false);
    	end
    end

    local planLevel = DataCenter.exclusivePlanData.planLevel;
    local maxLevel = DataCenter.exclusivePlanData.maxLevel;
    if DataCenter.exclusivePlanData.taskState == 1 and (planLevel ~= maxLevel) then
    	if self.taskRedPointIcon == nil then
    		self.taskRedPointIcon = Lua_RedPointIcon.new(self.content);
			self.taskRedPointIcon:createRedPointEff();
			self.taskRedPointIcon:setLocation(313, -435);
		end
		self.taskRedPointIcon:updateRedPointShow(true);
    else
    	if self.taskRedPointIcon ~= nil then
    		self.taskRedPointIcon:updateRedPointShow(false);
    	end
    end
    self:startTimerDown();
    self.bOpenUpdate = false;
end

function Lua_ExclusivePlanPanel:showCardTips()
	if DataCenter.exclusivePlanUtil.isNoNeedAppear ~= true then
		Lua_WindowUtil.openWin("Lua_ExclusivePlanCardTipsWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_ExclusivePlanPanel:onTimeDown()
	if self.realTime <= 0 then
		self:removeTimerDown();
		self.timeDownTxt:setLangValue(450022);
		return;
	end
	local str = Lua_TimeTransform.transSeconds18(self.realTime, true, true, true, true);
	self.timeDownTxt.text = LanUtil.formateStr(450000, str);
	self.realTime = self.realTime - 1;
end

function Lua_ExclusivePlanPanel:startTimerDown()
	local endTime = DataCenter.exclusivePlanData.endTime;
	local serverTime = DataCenter.roleData.serverTime;
	if endTime == nil or serverTime == nil then
		return;
	end
	self.realTime = endTime - serverTime;
	self:onTimeDown();
    if self.hasTimer ~= true then
    	self.hasTimer = true;
		self:addTimer("OnTimeDown", 1, self, self.onTimeDown);
    end
end

function Lua_ExclusivePlanPanel:removeTimerDown()
	if self.hasTimer == true then
		self.hasTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onTimeDown);
	end
end

function Lua_ExclusivePlanPanel:onCardShow()
	Lua_WindowUtil.openWin("Lua_ExclusivePlanCardShowWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ExclusivePlanPanel:getAllReward()
	if self.realTime <= 0 then
		OperateAlert.showLangValue(450022);
		return;
	end
	Lua_ProxyManager.getProxy("Lua_ExclusivePlanProxy"):sGetAllReward();
end

function Lua_ExclusivePlanPanel:onExtraExpClick()
	if self.realTime <= 0 then
		OperateAlert.showLangValue(450022);
		return;
	end
	if DataCenter.exclusivePlanData.planType == 1 then
		if DataCenter.exclusivePlanData.extraExpState == 1 then
			Lua_ProxyManager.getProxy("Lua_ExclusivePlanProxy"):sGetExtraExp();
		else
			OperateAlert.showLangValue(450001);
		end
	else
		OperateAlert.showLangValue(450002);
	end
end

function Lua_ExclusivePlanPanel:onLevelUp()
	if self.realTime <= 0 then
		OperateAlert.showLangValue(450022);
		return;
	end
	local curLevel = DataCenter.exclusivePlanData.planLevel;
	local maxLevel = #DataCenter.exclusivePlanData.stateList;
	local buyOpenTime = DataCenter.exclusivePlanUtil.buyOpenTime or 0;
	if curLevel and maxLevel then
		if curLevel >= maxLevel then
			OperateAlert.showLangValue(450019);
			return;
		end	
	end
	if self.realTime > 0 and self.realTime < buyOpenTime * 24 * 3600 then
		Lua_WindowUtil.openWin("Lua_ExclusivePlanLevelBuyWindow", Lua_WinParam.ACTION_OPEN);
	else
		local str = LanUtil.formateStr(450020, buyOpenTime);
		OperateAlert.show(str);
	end
end

function Lua_ExclusivePlanPanel:onEspecialPlanBuy()
	if self.realTime <= 0 then
		OperateAlert.showLangValue(450022);
		return;
	end
	if DataCenter.exclusivePlanData.planType == 1 then
		OperateAlert.showLangValue(450016);
	elseif DataCenter.exclusivePlanData.planType == 0 then
		Lua_WindowUtil.openWin("Lua_EspecialPlanBuyWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_ExclusivePlanPanel:onGoTask()
	if self.realTime <= 0 then
		OperateAlert.showLangValue(450022);
		return;
	end
	Lua_WindowUtil.openWin("Lua_ExclusivePlanTaskWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ExclusivePlanPanel:onHelpClick()
	local data = {des = LanUtil.getValue(450003), posX = 195, posY = -221};
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, data);
end

function Lua_ExclusivePlanPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_ExclusivePlanPanel:dispose()
	if self.roundList ~= nil then
		self.roundList:dispose();
		self.roundList = nil;
	end
	-- if self.flashItem ~= nil then
	-- 	self.flashItem:dispose();
	-- 	self.flashItem = nil;
	-- end
	if self.roleInfoPanel ~= nil then
		self.roleInfoPanel:dispose();
		self.roleInfoPanel = nil;
	end
	if self.taskRedPointIcon ~= nil then
		self.taskRedPointIcon:dispose();
		self.taskRedPointIcon = nil;
	end
	if self.expRedPoint ~= nil then
		self.expRedPoint:dispose();
		self.expRedPoint = nil;
	end
	self:removeTimerDown();

	self:superCall("dispose");
end








Lua_ExclusivePlanLevelItem = class("Lua_ExclusivePlanLevelItem", Lua_RoundItem);
function Lua_ExclusivePlanLevelItem:ctor(p)
	self:superCall("ctor", p, "ExclusivePlanLevelRewardItem_skin");
end

function Lua_ExclusivePlanLevelItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemArr = Array();
end

function Lua_ExclusivePlanLevelItem:setData(id)
	self.id = id;
	local vo = DataCenter.exclusivePlanData:getLevelVoById(id);

	if vo == nil then
		return;
	end

	self.levelNumTxt.text = vo.level;

	local len = self.itemArr:getSize();
	local dataLen = #vo.reward + #vo.seniorReward;
	local maxLen = dataLen > len and dataLen or len;
	local itemVoList = vo:getItemVoList();
	local planType = DataCenter.exclusivePlanData.planType;

	local item;
	for i = 1, maxLen do
		item = self.itemArr[i]
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
	    else
	    	if item == nil then
	    		item = Lua_ExclusivePlanItemCell.new(self.content);
	    		self.itemArr:add(item);	
		    else
		    	item:setEnable(true);
		    end
		    if i <= #vo.reward then
		    	item:setLocation(-30 + (i - 1) * 72, 2);
			    item.lockIcon:setEnable(false)
			    item.redPoint:updateRedPointShow(vo.state == 1)
			    item.itemIcon:setDrawMask(vo.state == 2)
			    --item:setData(vo.reward[i]);
			else
				item:setLocation(62 + (i - 1 - #vo.reward) * 72, 2);
			    item.lockIcon:setEnable(planType ~= 1)
			    item.redPoint:updateRedPointShow(vo.seniorState == 1)
				item.itemIcon:setDrawMask(vo.seniorState == 2)
				--item:setData(vo.seniorReward[i - #vo.reward]);
			end
			
			if itemVoList ~= nil then
				item:setData(itemVoList[i])
			end
		end
	end
end

function Lua_ExclusivePlanLevelItem:onPressClick()
	local vo = DataCenter.exclusivePlanData:getLevelVoById(self.id);
	local planType = DataCenter.exclusivePlanData.planType;
    
    --self.pressItem = self:checkClick();
    if self.pressItem == nil or self.clickIndex == nil then
    	return;
    end
	
	if self.clickIndex <= #vo.reward then
		if vo.state == 1 or vo.seniorState == 1 then
			local realTime = DataCenter.exclusivePlanData.endTime - DataCenter.roleData.serverTime;
			if realTime <= 0 then
				OperateAlert.showLangValue(450022);
				return;
			end
			Lua_ProxyManager.getProxy("Lua_ExclusivePlanProxy"):sGetReward(self.id);
		elseif vo.state == 0 then
			OperateAlert.showLangValue(450004);
			DataCenter.packUtil:showItemInfo(self.pressItem.tvo, nil);
		elseif vo.state == 2 then
			DataCenter.packUtil:showItemInfo(self.pressItem.tvo, nil);
		end
	else
		if vo.state == 1 or vo.seniorState == 1 then
			local realTime = DataCenter.exclusivePlanData.endTime - DataCenter.roleData.serverTime;
			if realTime <= 0 then
				OperateAlert.showLangValue(450022);
				return;
			end
			Lua_ProxyManager.getProxy("Lua_ExclusivePlanProxy"):sGetReward(self.id);
		elseif vo.seniorState == 0 then
			OperateAlert.showLangValue(450004);
			if planType ~= 1 then
				Lua_WindowUtil.openWin("Lua_EspecialPlanBuyWindow", Lua_WinParam.ACTION_OPEN);
			else
				DataCenter.packUtil:showItemInfo(self.pressItem.tvo, nil);
			end
		elseif vo.seniorState == 2 then
			DataCenter.packUtil:showItemInfo(self.pressItem.tvo, nil);
		end
	end
end

function Lua_ExclusivePlanLevelItem:checkClick()
	for i = 1, self.itemArr:getSize() do
		local winPos = LuaUtil.getTouchPosInverseObj(self.itemArr[i].mainContent);
		if self.itemArr[i].itemIcon:checkInBound(winPos.x, winPos.y) then
			if self.itemArr[i].isActive == false then
				return nil, nil;
			else
				return i, self.itemArr[i];
			end
		end
	end
	return nil, nil;
end

function Lua_ExclusivePlanLevelItem:onMouseDownHandle()
	self.clickIndex, self.pressItem = self:checkClick();
    if self.pressItem == nil then
    	return;
    end
	self.pressItem.itemIcon:setScale(0.475, 0.475);
end

function Lua_ExclusivePlanLevelItem:onMouseUpHandle()
	if self.pressItem == nil then
    	return;
    end
	self.pressItem.itemIcon:setScale(0.5, 0.5);
end

function Lua_ExclusivePlanLevelItem:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	if self.pressItem ~= nil then
		self.pressItem:dispose();
		self.pressItem = nil;
	end

	self:superCall("dispose");
end












Lua_ExclusivePlanItemCell = class("Lua_ExclusivePlanItemCell", Lua_DisplayObject)
function Lua_ExclusivePlanItemCell:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ExclusivePlanItemCell:buildShowItem()
	self:superCall("buildShowItem");
    
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(0, 0);
    self.itemIcon:setScale(0.5, 0.5);

    self.redPoint = Lua_RedPointIcon.new(self.content);
    self.redPoint:createRedPointEff();
    self.redPoint:setLocation(25, 25);
    self.redPoint:setScale(0.8, 0.8);
    
    self.lockIcon = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_label_23", 25, 25, 21, 27);
end

function Lua_ExclusivePlanItemCell:setData(data)
	self.tvo = data;
	self.itemIcon:setData(self.tvo);
end

function Lua_ExclusivePlanItemCell:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.tvo = nil;

	self:superCall("dispose")
end