--独家企划任务窗口
Lua_ExclusivePlanTaskWindow = class("Lua_ExclusivePlanTaskWindow", Lua_Window)
function Lua_ExclusivePlanTaskWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;
	self.windowName = "Lua_ExclusivePlanTaskWindow";
	self.skinName = "ExclusivePlanTaskWindow_skin";
end

function Lua_ExclusivePlanTaskWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.taskDragList = Lua_DragList.new(self.content, 630, 770, Lua_AxisDefine.Vertical);
	self.taskDragList:setListCell(Lua_ExclusivePlanTaskItem, 630, 145, 1);
	self.taskDragList:setLocation(0, -42);
    
	self:addLuaEvent("UPDATE_TASK_INFO", self, self.updateTaskList);
	Lua_ProxyManager.getProxy("Lua_ExclusivePlanProxy"):sGetTaskInfo();
end

function Lua_ExclusivePlanTaskWindow:updateTaskList()
    local taskIdArr = DataCenter.exclusivePlanData:sortTaskIdArr();
	self.taskDragList:setArrayData(taskIdArr);
end

function Lua_ExclusivePlanTaskWindow:dispose()
	if self.taskDragList ~= nil then
		self.taskDragList:dispose();
		self.taskDragList = nil;
	end

	self:superCall("dispose");
end








Lua_ExclusivePlanTaskItem = class("Lua_ExclusivePlanTaskItem", Lua_ListCell)
function Lua_ExclusivePlanTaskItem:ctor(p)
	self:superCall("ctor", p, "ExclusivePlanTaskItem_skin");
end

function Lua_ExclusivePlanTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_ItemIconList.new(self.content);
	self.itemList:setLocation(38, 0);
	self.itemList.scaleVal = 0.8;
	self.itemList:setSiblingIndex(self.timesTxt.siblingIndex);

	self.getBtn:addClickFuntion(self, self.onGetBtnClick);
end

function Lua_ExclusivePlanTaskItem:setData(taskId)
	self.data = DataCenter.exclusivePlanData:getTaskVoById(taskId);
	if self.data == nil then
		return;
	end
	self.itemList:setArrayData(self.data.taskReward);

	self.getBtn:setEnable(self.data.state ~= 2);
	self.timesTxt:setEnable(self.data.state ~= 2);
	self.completeIcon:setEnable(self.data.state == 2);
	self.maskImg:setEnable(self.data.satisfyLevel == false or self.data.satisfyplanType == false);
	self.conditionTxt:setEnable(self.data.satisfyLevel == false or self.data.satisfyplanType == false);
	self.timesTxt:setEnable(self.data.state ~= 2);

	local curProgress;
	if self.data.progress < self.data.targetVal then
		curProgress = Lua_ColorDefine.getColorStr("ee4d30", self.data.progress);
	else
		curProgress = Lua_ColorDefine.getColorStr("469252", self.data.progress);
	end
    
	if self.data.state == 0 then
		self.getBtn.label = LanUtil.getValue(450006);
		self.getBtn:setStyle(7);

		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	elseif self.data.state == 1 then
		self.getBtn.label = LanUtil.getValue(450007);
		self.getBtn:setStyle(5);
		if self.data.satisfyLevel and self.data.satisfyplanType then
			self.getBtn:setBtnEnable(true);
	    else
	    	self.getBtn:setBtnEnable(false);
	    end

	    if self.redPoint == nil then
	    	self.redPoint = Lua_RedPointIcon.new(self.content);
	    	self.redPoint:createRedPointEff();
	    	self.redPoint:setLocation(268, 5);
	    end
	    local planLevel = DataCenter.exclusivePlanData.planLevel;
	    local maxLevel = DataCenter.exclusivePlanData.maxLevel;
	    self.redPoint:updateRedPointShow(planLevel ~= maxLevel);
	elseif self.data.state == 2 then
		curProgress = Lua_ColorDefine.getColorStr("469252", self.data.targetVal);

		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end

	self.descTxt.text = LanUtil.formateStr(450015, self.data.describe, curProgress, self.data.targetVal);
	self.timesTxt.text = LanUtil.formateStr(450005, self.data.taskTimes - self.data.times);

    if self.data.satisfyLevel == false and self.data.satisfyplanType == true then
    	self.conditionTxt.text = LanUtil.formateStr(450008, self.data.opendLevel);
    else
    	self.conditionTxt:setLangValue(450009);
    end
end

function Lua_ExclusivePlanTaskItem:onPressClick()
	if self.data.satisfyLevel == false or self.data.satisfyplanType == false then
		return;
	end
	if self.pressItem ~= nil then
		self.pressItem:onItemClick();
	end
end

function Lua_ExclusivePlanTaskItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.itemList.mainContent);
	for i = 1, self.itemList.showArr:getSize() do
		if self.itemList.showArr[i]:checkInBound(winPos.x, winPos.y) then
			return self.itemList.showArr[i];
		end
	end
	return nil;
end

function Lua_ExclusivePlanTaskItem:onMouseDownHandle()
	if self.data.satisfyLevel == false or self.data.satisfyplanType == false then
		return;
	end

	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.76, 0.76);
	end
end

function Lua_ExclusivePlanTaskItem:onMouseUpHandle()
	if self.data.satisfyLevel == false or self.data.satisfyplanType == false then
		return;
	end

	if self.pressItem ~= nil then
		self.pressItem:setScale(0.8, 0.8);
	end
end

function Lua_ExclusivePlanTaskItem:onGetBtnClick()
	if self.data.state == 0 then
		if self.data.eventId ~= nil then
			DataCenter.funcPathUtil:gotoFunction(self.data.eventId);
			Lua_WindowUtil.openWin("Lua_ExclusivePlanTaskWindow", Lua_WinParam.ACTION_CLOSE);
			Lua_WindowUtil.openWin("Lua_WarOrderWindow", Lua_WinParam.ACTION_CLOSE);
	    end
	elseif self.data.state == 1 then
		Lua_ProxyManager.getProxy("Lua_ExclusivePlanProxy"):sGetTaskReward(self.data.id);
	end
end

function Lua_ExclusivePlanTaskItem:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.pressItem ~= nil then
		self.pressItem:dispose();
		self.pressItem = nil;
	end

	self:superCall("dispose");
end