-- 等级礼包
Lua_GradeGiftPanel = class("Lua_GradeGiftPanel", Lua_DisplayObject);
function Lua_GradeGiftPanel:ctor(p)
	self:superCall("ctor", p, "GradeGiftPanel_skin");
end

function Lua_GradeGiftPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.level_txt.text = LanUtil.formateStr(200903, DataCenter.roleData.level);

	self.rewardList = Lua_DragList.new(self.content, 672, 826 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.rewardList.tweenId = 2002;
	self.rewardList:setListCell(Lua_GradeGiftItem, 672, 181, 1);
	self.rewardList:setCellSpacing(0, 6);
	self.rewardList:setRectAnchor(1);
	self.rewardList:setLocation(0, -831 - self.adaptHeight / 2, 0, 0);

	self:addLuaEvent("UPDATE_GRADEGIFT_REWARD", self, self.updateGradeGiftData);
	Lua_ProxyManager.getProxy("Lua_WelfareProxy"):sOpenGradeGiftInfo();
end

function Lua_GradeGiftPanel:setData(data)
end

function Lua_GradeGiftPanel:updateGradeGiftData()
	self.rewardList:setArrayData(DataCenter.welfareData.giftInfoArr);
end

function Lua_GradeGiftPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.rewardList:setContentRect(672, 826 + adaptHeight);
	self.rewardList:setLocation(0, -831 - adaptHeight / 2, 0, 0);
end

function Lua_GradeGiftPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_GradeGiftItem = class("Lua_GradeGiftItem", Lua_ListCell);
function Lua_GradeGiftItem:ctor(p)
    self:superCall("ctor", p, "GradeGiftItem_skin");
end

function Lua_GradeGiftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 400, 93, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_GradeGiftSubItem, 93, 93, 1);
	self.rewardList:setCellSpacing(9, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-300, -11, 0);
	self:setSubList(self.rewardList);

 	self.stateBtn:addClickFuntion(self, self.onBtnClick);
end

function Lua_GradeGiftItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

 	self.tipsTxt.text = LanUtil.formateStr(200900, tostring(data.level));
 	self.rewardList.canDrag = #data.reward > 5;
	self.rewardList:setArrayData(data.reward);

	if DataCenter.roleData.level >= data.level then
		self.stateBtn:setStyle(1);
		self.stateBtn.txt.colorStr = Lua_ColorDefine.transColorStr("8A5A37");
		self.stateBtn:setLangValue(200901);
	else
		self.stateBtn:setStyle(3);
		self.stateBtn.txt.colorStr = Lua_ColorDefine.transColorStr("74604F");
		self.stateBtn:setLangValue(200902);
	end
	self.stateBtn:setEnable(not data.isDraw);
	self.receivedSp:setEnable(data.isDraw);
	self:showRedDot(data.isCanDraw);
end

function Lua_GradeGiftItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onUpClick();
	end
end

function Lua_GradeGiftItem:checkClick()
	local showArr = self.rewardList.showList;
	for i = 1, showArr:getSize() do
		winPos = LuaUtil.getTouchPosInverseObj(showArr[i].mainContent);
		if showArr[i].itemIcon.isActive and showArr[i].itemIcon:checkInBound(winPos.x, winPos.y) then
			return showArr[i];
		end
	end
	return nil;
end

function Lua_GradeGiftItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.9, 0.9);
	end
end

function Lua_GradeGiftItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(1, 1);
	end
end

function Lua_GradeGiftItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(287, 3, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_GradeGiftItem:onBtnClick(go)
	if DataCenter.roleData.level >= self._data.level then
		Lua_ProxyManager.getProxy("Lua_WelfareProxy"):sReceiveGradeGift(self._data.id);
	else
		DataCenter.funcPathUtil:gotoFunction(1005, true)
	end
end

function Lua_GradeGiftItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_GradeGiftSubItem = class("Lua_GradeGiftSubItem", Lua_ItemIconCell);
function Lua_GradeGiftSubItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.75, 0.75);
end

function Lua_GradeGiftSubItem:onPressClick()
end

function Lua_GradeGiftSubItem:onUpClick()
	if self.data == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.data);
end