-- 月卡
Lua_MonthCardPanel = class("Lua_MonthCardPanel", Lua_DisplayObject);
function Lua_MonthCardPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_MonthCardPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.titleIcon = UICreate.createImage(self.content, "/images/activities/xui_yk_zi_1.png", 166, -298, 0, 0);
	self.titleIcon.anchorValue = 1;

	self.cardList = Lua_DragList.new(self.content, 714, 787, Lua_AxisDefine.Horizontal);
	self.cardList.tweenId = 2022;
	self.cardList:setListCell(Lua_MonthCardItem, 357, 787, 1);
	self.cardList:setLocation(0, -113, 0);

	self:addLuaEvent("UPDATE_MONTHCARD_INFO", self, self.updateMonthCardInfo);
	-- Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sMonthCardInInfo();
	self:updateMonthCardInfo();
end

function Lua_MonthCardPanel:setData(actVo)
end

function Lua_MonthCardPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_MonthCardPanel:updateMonthCardInfo()
	local arr = DataCenter.monthCardData.monthCardArr;
	if arr == nil then return; end
	self.cardList.canDrag = arr:getSize() > 2;
	self.cardList:setArrayData(arr);
end

function Lua_MonthCardPanel:dispose()
	if self.titleIcon ~= nil then
		self.titleIcon:dispose();
		self.titleIcon = nil;
	end
	if self.cardList ~= nil then
		self.cardList:dispose();
		self.cardList = nil;
	end
	self:superCall("dispose");
end










Lua_MonthCardItem = class("Lua_MonthCardItem", Lua_ListCell);
function Lua_MonthCardItem:ctor(p)
    self:superCall("ctor", p, "MonthCardItem_skin");
end

function Lua_MonthCardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.receiveBtn:addClickFuntion(self, self.onActiveClick);
end

function Lua_MonthCardItem:setData(data)
	self._data = DataCenter.monthCardData:getMonthCardVo(data);
	if self._data == nil then
		return;
	end

	self.itemBg:setUrl(self._data.card_bg);
	self.cardIcon:setAltas(self._data.icon_atlas, self._data.icon_sprite);

	self.dailyNum.text = self._data.reward[2];
	self.totalNum.text = self._data.total_Reward;
	self.tips.text = LanUtil.formateStr(202400, self._data.leftTime);
	self.tips:setLocation(0, -236, 0);
	
	if self._data.drawState == 0 then
		self.receiveBtn:setLangValue(202402);

		self.progressBar:setMaxValue(self._data.total_recharge);
		self.progressBar:setValue(self._data.aggregatment);
		self.progressBar:setText(LanUtil.formateStr(202404, tostring(self._data.aggregatment), tostring(self._data.total_recharge)));

		self.tips.text = LanUtil.formateStr(202405, tostring(self._data.total_recharge));
	elseif self._data.drawState == 1 then
		self.receiveBtn:setLangValue(202401);
	else
		self.tips:setLocation(0, -210, 0);
		self.receiveBtn:setLangValue(202403);
	end
	
	self.progressBar:setEnable(self._data.drawState == 0);
	-- self.receiveBtn:setGray(self._data.drawState == 2);
	self.receiveBtn:setEnable(self._data.drawState ~= 2);
	self.drawedIcon:setEnable(self._data.drawState == 2);
	self:showRedDot(self._data.drawState == 1);
end

function Lua_MonthCardItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(108, -275, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_MonthCardItem:onActiveClick()
	if self._data.drawState == 0 then
		DataCenter.funcPathUtil:gotoFunction(1024);
	elseif self._data.drawState == 1 then
		Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sGetMonthCardReward(self._data.grade);
	-- else
	-- 	OperateAlert.showLangValue(202403);
	end
end

function Lua_MonthCardItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end