-- 开服试炼-英雄挑战个人阶段伤害奖励界面
Lua_HeroChallengeHurtRewardWindow = class("Lua_HeroChallengeHurtRewardWindow", Lua_Window);
function Lua_HeroChallengeHurtRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroChallengeHurtRewardWindow";
	self.skinName = "HeroChallengeHurtRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_HeroChallengeHurtRewardWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.tipsTxt:setLangValue(680020);

	self.itemList = Lua_DragList.new(self.content, 628, 720, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_HeroChallengeHurtRewardItem, 628, 165, 1);
	self.itemList:setLocation(0, -85, 0);
	self.itemList:setArrayData(DataCenter.heroChallengeData.daily_hurt_reward);
	self.itemList:moveToIndex(DataCenter.heroChallengeData.curStageIdx, true, false);
end

function Lua_HeroChallengeHurtRewardWindow:dispose()
	if self.itemList then
		self.itemList:dispose()
		self.itemList = nil
	end
	self:superCall("dispose")
end










Lua_HeroChallengeHurtRewardItem = class("Lua_HeroChallengeHurtRewardItem", Lua_ListCell);
function Lua_HeroChallengeHurtRewardItem:ctor(p)
	self:superCall("ctor", p, "HeroChallengeHurtRewardItem_skin");
end

function Lua_HeroChallengeHurtRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 420, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_HeroChallengeHurtRewardIconItem, 87, 87, 1);
	self.rewardList:setLocation(-80, -20.5, 0);
	self.rewardList:setCellSpacing(5, 0);
	self:setSubList(self.rewardList);
end

function Lua_HeroChallengeHurtRewardItem:setData(data)
	if data == nil then
		return;
	end

	self.titleTxt.text = LanUtil.formateStr(680011, data.hurt);
	self.rewardList.canDrag = #data.item_list > 4;
	self.rewardList:setArrayData(data.item_list);

	-- 是否达成(0否 1是)
	if data.is_finish == 0 then
		self.stateIcon:setAltas("common_altas_4", "xui_common_label_28")
	else
		self.stateIcon:setAltas("common_altas_4", "xui_common_label_30")
	end
end

function Lua_HeroChallengeHurtRewardItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onUpClick();
	end
end

function Lua_HeroChallengeHurtRewardItem:checkClick()
	local showArr = self.rewardList.showList;
	for i = 1, showArr:getSize() do
		winPos = LuaUtil.getTouchPosInverseObj(showArr[i].mainContent);
		if showArr[i].itemIcon.isActive and showArr[i].itemIcon:checkInBound(winPos.x, winPos.y) then
			return showArr[i];
		end
	end
	return nil;
end

function Lua_HeroChallengeHurtRewardItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.9, 0.9);
	end
end

function Lua_HeroChallengeHurtRewardItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(1, 1);
	end
end

function Lua_HeroChallengeHurtRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_HeroChallengeHurtRewardIconItem = class("Lua_HeroChallengeHurtRewardIconItem", Lua_ItemIconCell)
function Lua_HeroChallengeHurtRewardIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end

function Lua_HeroChallengeHurtRewardIconItem:onUpClick()
	if self.data == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.data);
end

function Lua_HeroChallengeHurtRewardIconItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onItemClick();
	end
end

function Lua_HeroChallengeHurtRewardIconItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.itemIcon.isActive and self.itemIcon:checkInBound(winPos.x, winPos.y) then
		return self.itemIcon;
	end
	return nil;
end

function Lua_HeroChallengeHurtRewardIconItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.6, 0.6);
	end
end

function Lua_HeroChallengeHurtRewardIconItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.7, 0.7);
	end
end