-- 开服试炼-英雄赠礼
Lua_OpenServerHeroGiftPanel = class("Lua_OpenServerHeroGiftPanel", Lua_DisplayObject);
function Lua_OpenServerHeroGiftPanel:ctor(p)
	self:superCall("ctor", p, "OpenServerHeroGiftPanel_skin");
end

function Lua_OpenServerHeroGiftPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.showItemArr = Array();
	local openServerHeroGiftData = DataCenter.openServerHeroGiftData;
	openServerHeroGiftData.isOpen = 1;

	local itemInfo = getConfig("item", openServerHeroGiftData.drawItemId);
	self.itemIcon_1:setAltas(itemInfo.atlas, itemInfo.sprite);
	self.itemIcon_2:setAltas(itemInfo.atlas, itemInfo.sprite);

	self.redPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.OpenServerTrial_HeroGift);
	self.redPoint:setLocation(98, -230, 0);
	
	self.btnList = Lua_DragList.new(self.content, 710, 148, Lua_AxisDefine.Horizontal);
	self.btnList:setListCell(Lua_OpenServerHeroGiftBtnItem, 234, 148, 1);
	self.btnList:setCellSpacing(4, 0);
	self.btnList:setLocation(0, -448, 0);

	self.infoIcon:addLoadCompleteFun(self, self.onCompletelick_1);
	self.nameIcon:addLoadCompleteFun(self, self.onCompletelick_2);
	self.addBtn:addClickFuntion(self, self.onAddClick);
	self.drawBtn:addClickFuntion(self, self.onDrawClick);

	self:addLuaEvent("MONEY_UPDATE", self, self.updateItemNumShow); -- 货币数量增加时更新红点
	self:addLuaEvent("UPDATE_OPENSERVER_HEROGIFT_INFO", self, self.updateOpenServerHeroGiftData);
	Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sOpenServerHeroGiftInfo();
end

function Lua_OpenServerHeroGiftPanel:setData(data)
end

function Lua_OpenServerHeroGiftPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_OpenServerHeroGiftPanel:updateOpenServerHeroGiftData()
	self:starTimer();
	self:updateTimer();
	self:updateItemNumShow();

	local openServerHeroGiftData = DataCenter.openServerHeroGiftData;
	local arr = openServerHeroGiftData:curRoundShowArr();
	if self.isPlayTween then
		Lua_CommonUtil.removeTimer(self, self.onDelayCallFun);
		self.selectTab = {};
		for i = 1, arr:getSize() do
			if not arr[i].isDrawed or (arr[i].isDrawed and arr[i].id == openServerHeroGiftData.cell_num) then
				self.selectTab[#self.selectTab + 1] = i;
			end
		end

		if #self.selectTab > 1 then
			self.startNum = 0;
			self.circleNum = arr:getSize();
			self.endPos = openServerHeroGiftData.cell_num % 10000;
			self:startPlayTween();
			self:updatePlyaTween();
		else
			self.endPos = openServerHeroGiftData.cell_num % 10000;
			self.lightTimes = 5;
			self.showOrHide = true;
			self.showItemArr[self.endPos]:setShowHide(self.showOrHide);
			self:startPlayLight();
		end
	else
		if self.showItemArr:getSize() > openServerHeroGiftData.roundMaxNum then
			for i = openServerHeroGiftData.roundMaxNum + 1, self.showItemArr:getSize() do
				self.showItemArr:remove(openServerHeroGiftData.roundMaxNum + 1);
			end
		end

		local posList = openServerHeroGiftData.posList;
		local posX;
		local posY;
		local index = 0;
		for i = 1, #posList do
			for j = 1, posList[i] do
				posX = -(posList[i] + 1) / 2 * 138 + j * 138;
				posY = 280 - i * 134;

				index = index + 1;
				item = self.showItemArr[index];
				if item == nil then
					item = Lua_OpenServerHeroGiftItem.new(self.content);
					item.contentName = "Lua_OpenServerHeroGiftItem_" .. index;
					item:setLocation(posX, posY);
					item:setEnable(self.isFirstIn);
					self.showItemArr:add(item);
				end
				item:setData(arr[index]);
			end
		end

		if not self.isFirstIn then
			self.isFirstIn = true;
			self.tweenIdx = 0;
			self:addTimer("Lua_OpenServerHeroGiftPanel", 0.04, self, self.onPlayTween);
		end
	end

	if self.round_num ~= openServerHeroGiftData.round_num then
		self.tipsTxt.text = LanUtil.formateStr(660005, openServerHeroGiftData.roundMaxNum);
		self.tipsTxt:resetSize();

		local len = openServerHeroGiftData.entranceDic:getSize();
		local posX = len > 2 and 0 or (710 - len * 234 - (len - 1) * 4) / 2;
		self.btnList.canDrag = len > 3;
		self.btnList:setArrayData(openServerHeroGiftData.entranceDic);
		self.btnList:setLocation(posX, -448, 0);

		self.infoIcon:setAltas(openServerHeroGiftData.iconList[1][1], openServerHeroGiftData.iconList[1][2]);
		self.nameIcon:setAltas(openServerHeroGiftData.iconList[2][1], openServerHeroGiftData.iconList[2][2]);
		self.nameIcon:setLocation(self.tipsTxt.posX + self.tipsTxt.width - 2, 21, 0);
		self.heroImg:SetDimensions(0, 0);
		self.heroImg:setUrl(nil);
		self.heroImg:setUrl(openServerHeroGiftData.iconList[3]);
	end
	self.round_num = openServerHeroGiftData.round_num;
end

function Lua_OpenServerHeroGiftPanel:starTimer()
	if self.timeCountDown ~= true then
		self.timeCountDown = true;
		self:addTimer("PlayTime", 1, self, self.updateTimer);
	end
end

function Lua_OpenServerHeroGiftPanel:updateTimer()
	local time = Mathf.Ceil(DataCenter.openServerHeroGiftData.end_time - DataCenter.roleData.serverTime);
	self.leftTimeTxt.text = LanUtil.formateStr(660000, Lua_TimeTransform.transSeconds1(time, true, true, true));
	if time < 0 then
		self:endTimer();
	end
end

function Lua_OpenServerHeroGiftPanel:endTimer()
	if self.timeCountDown == true then
		self.timeCountDown = false;
		self:removeTimer(self, self.updateTimer);
	end
end

function Lua_OpenServerHeroGiftPanel:updateItemNumShow()
	local openServerHeroGiftData = DataCenter.openServerHeroGiftData;
	local hasCount = DataCenter.packData:getItemCountById(openServerHeroGiftData.drawItemId);
	local needCount = openServerHeroGiftData.drawItemNum;
	self.numTxt.text = LanUtil.formateStr(660002, "E5E5E5", hasCount);

	local arr = openServerHeroGiftData:curRoundShowArr();
	if needCount == 0 then
		-- self.numTxt:setLangValue(660001);
		self.drawBtn:setLangValue(660003);
	else
		-- local colorStr = hasCount >= needCount and "3A9F3C" or "ED4C30";
		-- self.numTxt.text = LanUtil.formateStr(660002, colorStr, hasCount, needCount);

		local colorStr = hasCount >= needCount and "8F5123" or "ED4C30";
		local itemInfo = Lua_ToolVo.createToolVo(openServerHeroGiftData.drawItemId);
		local itemStr = spliceIconStr(itemInfo.atlas, itemInfo.sprite, itemInfo.iconWidth, itemInfo.iconHeight);
		self.drawBtn.label = spliceStr(itemStr, "<color=#", colorStr, ">", needCount, "</color>", LanUtil.getValue(660004));
	end
	self.drawBtn:setGray(arr:getSize() <= openServerHeroGiftData.draw_num);
end

function Lua_OpenServerHeroGiftPanel:startPlayTween()
	if self.tweenCountDown ~= true then
		self.tweenCountDown = true;
		self:addTimer("PlayTween", 0.1, self, self.updatePlyaTween);
	end
end

function Lua_OpenServerHeroGiftPanel:updatePlyaTween()
	self.startNum = self.startNum + 1;
	self.prePos = self.curPos;

	if self.startNum >= self.circleNum + self.endPos then
		self:endPlayTween();

		self.lightTimes = 5;
		self.showOrHide = true;
		self.curPos = self.endPos;
		self:startPlayLight();
	else
		local idx = Mathf.Random(1, #self.selectTab);
		self.curPos = self.selectTab[idx];
		if self.curPos == self.prePos then
			idx = idx + 1 > #self.selectTab and 1 or idx + 1;
			self.curPos = self.selectTab[idx];
		end
	end

	if self.startNum > 1 then
		self.showItemArr[self.prePos]:setShowHide(false);
	end
	self.showItemArr[self.curPos]:setShowHide(true);
end

function Lua_OpenServerHeroGiftPanel:endPlayTween()
	if self.tweenCountDown == true then
		self.tweenCountDown = false;
		self:removeTimer(self, self.updatePlyaTween);
	end
end

function Lua_OpenServerHeroGiftPanel:startPlayLight()
	if self.lightCountDown ~= true then
		self.lightCountDown = true;
		self:addTimer("PlayLight", 0.1, self, self.updatePlayLight);
	end
end

function Lua_OpenServerHeroGiftPanel:updatePlayLight()
	self.lightTimes = self.lightTimes - 1;
	self.showOrHide = not self.showOrHide;
	self.showItemArr[self.endPos]:setShowHide(self.showOrHide);
	if self.lightTimes <= 1 then
		self:endPlayLight();
	end
end

function Lua_OpenServerHeroGiftPanel:endPlayLight()
	if self.lightCountDown == true then
		self.lightCountDown = false;
		self:removeTimer(self, self.updatePlayLight);
		self:showReward();
		self:onDelayCallFun();
	end
end

function Lua_OpenServerHeroGiftPanel:showReward()
	local openServerHeroGiftData = DataCenter.openServerHeroGiftData;
	local info = openServerHeroGiftData.heroGiftDic[openServerHeroGiftData.cell_num].reward_item;
	local tvo = Lua_ToolVo.createToolVo(info[1], info[2]);
	if openServerHeroGiftData.heroInfo ~= nil and tvo.hero_id == openServerHeroGiftData.heroInfo.hero_id then
		tvo.isNew = openServerHeroGiftData.heroInfo.is_new;
	end

	local rewardArr = Array();
	rewardArr:add(tvo);
	Lua_WindowUtil.openWin("Lua_OpenServerShowRewardWindow", Lua_WinParam.ACTION_OPEN, rewardArr);
end

function Lua_OpenServerHeroGiftPanel:onPlayTween()
	self.tweenIdx = self.tweenIdx + 1;
	if self.tweenIdx > self.showItemArr:getSize() then
		self:removeTimer(self, self.onPlayTween);
		return;
	end
	local item = self.showItemArr[self.tweenIdx];
	item:setEnable(true);
	TweenUtil.getInstance():addTweenTargetAlpha(item.content, 0.2, 0, -1, true);
end

function Lua_OpenServerHeroGiftPanel:onCompletelick_1(go)
	self.infoIcon:resetSize();
end

function Lua_OpenServerHeroGiftPanel:onCompletelick_2(go)
	self.nameIcon:resetSize();
end

function Lua_OpenServerHeroGiftPanel:onAddClick(go)
	DataCenter.packUtil:openPathWindow(DataCenter.openServerHeroGiftData.drawItemId, false);
end

function Lua_OpenServerHeroGiftPanel:onDrawClick(go)
	local time = Mathf.Ceil(DataCenter.openServerHeroGiftData.end_time - DataCenter.roleData.serverTime);
	if time <= 0 then
		OperateAlert.showLangValue(660006);
		return;
	end
	
	local openServerHeroGiftData = DataCenter.openServerHeroGiftData;
	local hasCount = DataCenter.packData:getItemCountById(openServerHeroGiftData.drawItemId);
	local needCount = openServerHeroGiftData.drawItemNum;
	if hasCount >= needCount then
		local arr = openServerHeroGiftData:curRoundShowArr();
		if arr:getSize() > openServerHeroGiftData.draw_num then
			self:onDelayFun();
			Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sDrawOpenServerHeroGift();
		else
			OperateAlert.showLangValue(660008);
		end
	else
		DataCenter.packUtil:openPathWindow(DataCenter.openServerHeroGiftData.drawItemId, false);
	end
end

-- 播放动画增加遮罩，不可以执行其他操作
function Lua_OpenServerHeroGiftPanel:onDelayFun()
	self.isPlayTween = true;
	Lua_MsgUtil.callFunc("OPERATIONAL_ACTIVITIES_CLICKLIMIT", 1);
end

function Lua_OpenServerHeroGiftPanel:onDelayCallFun()
	self.isPlayTween = false;
	Lua_MsgUtil.callFunc("OPERATIONAL_ACTIVITIES_CLICKLIMIT", 0);
end

function Lua_OpenServerHeroGiftPanel:dispose()
	if self.showItemArr ~= nil then
		self.showItemArr:dispose();
		self.showItemArr:clear();
		self.showItemArr = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.isPlayTween = false;
	self:endTimer();
	self:endPlayTween();
	self:endPlayLight();
	self:removeTimer(self, self.onPlayTween);
	self:onDelayCallFun();
	TweenUtil.getInstance():stop(self.mainContent);
	DataCenter.openServerHeroGiftData.isOpen = 0;

	self:superCall("dispose");
end










Lua_OpenServerHeroGiftItem = class("Lua_OpenServerHeroGiftItem", Lua_DisplayObject);
function Lua_OpenServerHeroGiftItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_OpenServerHeroGiftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(true);

	self.selectIcon = UICreate.createUIAtlasImage(self.content, "online_atlas", "xui_zxjl_widget_4", 0, 0, 0, 0);
end

function Lua_OpenServerHeroGiftItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.reward_item[1], data.reward_item[2]);
	self.itemIcon:setData(tvo);
	self.itemIcon:setDrawMask(data.isDrawed);

	self.selectIcon:setEnable(false);
end

function Lua_OpenServerHeroGiftItem:setShowHide(state)
	self.selectIcon:setEnable(state);
end

function Lua_OpenServerHeroGiftItem:dispose()
	if self.itemIcon == nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.selectIcon == nil then
		self.selectIcon:dispose();
		self.selectIcon = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end










Lua_OpenServerHeroGiftBtnItem = class("Lua_OpenServerHeroGiftBtnItem", Lua_ListCell);
function Lua_OpenServerHeroGiftBtnItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_OpenServerHeroGiftBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemBg = UICreate.createUIAtlasImage(self.content, "trial_altas", "ui_shilian_widget_005", 0, 0, 0, 0);
end

function Lua_OpenServerHeroGiftBtnItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemBg:setAltas(data.atlas, data.sprite);
	if self.redPoint == nil then
		self:setRedPoint();
	end
end

function Lua_OpenServerHeroGiftBtnItem:setRedPoint()
	if self._data then
		self.redPoint = Lua_RedPointIcon.new(self.content, self._data.map_red_id);
		self.redPoint:setLocation(98, 55, 0);
		-- print(self._data.monitor_red_id, self._data.map_red_id);
	end
end

function Lua_OpenServerHeroGiftBtnItem:onPressClick()
	if self._data then
		DataCenter.funcPathUtil:gotoFunction(self._data.path_id, self._data.is_show_win == 1);
	end
end

function Lua_OpenServerHeroGiftBtnItem:dispose()
	if self.itemBg ~= nil then
		self.itemBg:dispose();
		self.itemBg = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end