Lua_UpStarOfServerSelectHeroWindow = class("Lua_UpStarOfServerSelectHeroWindow", Lua_Window);
function Lua_UpStarOfServerSelectHeroWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_UpStarOfServerSelectHeroWindow";
	self.skinName = "UpStarOfServerSelectHeroWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_UpStarOfServerSelectHeroWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.heroList = Lua_DragList.new(self.content, 600, 500, Lua_AxisDefine.Vertical);
	self.heroList:setListCell(Lua_UpStarOfServerSelectHeroItem, 120, 146, 5);
	self.heroList:setCellSpacing(0, 10);
	self.heroList:setLocation(0, 40, 0);

	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
	self.campSiftPanel:setCallBack(self, self.updateHeroSiftInfo);
	self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
	self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
	self.campSiftPanel:setLocation(0, -300, 0);

	self.sureBtn:addClickFuntion(self, self.onSureClick);
end

function Lua_UpStarOfServerSelectHeroWindow:updateHeroSiftInfo(curCampType)
	if self.preCampType == curCampType then
		return;
	end
	self.preCampType = curCampType;
	self:selectHeroByCampType(curCampType);
end

function Lua_UpStarOfServerSelectHeroWindow:selectHeroByCampType(campType)
	if campType == Lua_HeroUtil.All_TYPE then
		campType = nil;
	end

	local heroArr = DataCenter.upStarOfServerData:getHeroListArr(campType);
	self.heroList:setArrayData(heroArr);
	self.heroList:moveToIndex(1, true);
	
	local vo = DataCenter.upStarOfServerData.curSelectHero;
	if vo ~= nil then
		for i = 1, heroArr:getSize() do
			if heroArr[i] == vo then
				self.heroList:moveToIndex(i, true);
				self.heroList:setSelected(i);
				break;
			end
		end
	end
	self.tipsTxt:setEnable(heroArr:getSize() <= 0);
end

function Lua_UpStarOfServerSelectHeroWindow:onSureClick(go)
	local vo = DataCenter.upStarOfServerData.curSelectHero;
	if vo == nil then
		OperateAlert.showLangValue(203107);
	else
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sUpStarOfServerAddHero(vo.id, 1, vo.quality, vo.quality_star);
		self:hide();
	end
end

function Lua_UpStarOfServerSelectHeroWindow:dispose()
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	if self.heroList ~= nil then
		self.heroList:dispose();
		self.heroList = nil;
	end
	DataCenter.upStarOfServerData.curSelectHero = DataCenter.upStarOfServerData:getCurSelectHero();

	self:superCall("dispose");
end






--------------------------------------------------





Lua_UpStarOfServerSelectHeroItem = class("Lua_UpStarOfServerSelectHeroItem", Lua_ListCell);
function Lua_UpStarOfServerSelectHeroItem:ctor(p)
	self:superCall("ctor", p, "UpStarOfServerSelectHeroItem_skin");
end

function Lua_UpStarOfServerSelectHeroItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroIcon = Lua_ItemIcon.new(self.content);
	self.heroIcon:setLocation(0, 23, 0);
	self.heroIcon:setScale(0.8, 0.8);
end

function Lua_UpStarOfServerSelectHeroItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.heroIcon:setData(data);
	self.heroNameTxt.text = data.name;
end

function Lua_UpStarOfServerSelectHeroItem:onPressClick()
	DataCenter.upStarOfServerData.curSelectHero = self._data;
	return true;
end

function Lua_UpStarOfServerSelectHeroItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	self.heroIcon:setDrawMask(bSelect);
end

function Lua_UpStarOfServerSelectHeroItem:dispose()
	if self.heroIcon ~= nil then
		self.heroIcon:dispose();
		self.heroIcon = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end