-- VIP名望提升Tips
Lua_VipUpTipsWindow = class("Lua_VipUpTipsWindow", Lua_Window);
function Lua_VipUpTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_VipUpTipsWindow";
	self.skinName = "VipUpTipsWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -479;

	self:addPreLoadRes("/images/common/xui_common_bg_002.jpg", Lua_LoadFileType.IMG);
	self:addPreLoadRes("/images/common/xui_common_window_010.png", Lua_LoadFileType.IMG);
end

function Lua_VipUpTipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.showVipContainer = Lua_DragContainer.new(self.content, 720, 330, Lua_AxisDefine.Vertical);
	self.showVipContainer:setLocation(0, 56.5, 0);

	self.rewardList = Lua_DragList.new(self.content, 520, 93, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_VipUpTipsSubItem, 104, 93, 1);

	self.infoBg:addClickFuntion(self, self.onBtnCloseClick);
	self.gotoBtn:addClickFuntion(self, self.onGoToBtnClick);
end

function Lua_VipUpTipsWindow:showWin(param)
	self:superCall("showWin", param);

	self.preVipLvTxt.text = param - 1;
	self.curVipLvTxt.text = param;
	self.privilegeTxt.text = LanUtil.formateStr(320001, param);

	local vipVo = getConfig("vip", param);
	local arr = string.split(vipVo.privilege_des, "\n");
	self.showVipContainer:clearList();
	for i = 1, arr:getSize() do
		self.showVipContainer:addSubContainer(Lua_VipPrivilegeDesItem, arr[i]);
	end
	self.showVipContainer:updateChildPos();
	self.showVipContainer:moveToIndex(1, true, false);
	self.showVipContainer.canDrag = not self.showVipContainer.isTheEnd;

	local len = #vipVo.vip_reward;
	local posX = len > 5 and 0 or (520 - 104 * len) / 2;
	self.rewardList.canDrag = len > 5;
	self.rewardList:setArrayData(vipVo.vip_reward);
	self.rewardList:setLocation(posX, -226, 0);
end

function Lua_VipUpTipsWindow:onGoToBtnClick(go)
	DataCenter.vipData.isPos = true;
	DataCenter.funcPathUtil:gotoFunction(1034, true) -- 1034：VIP跳转id
	self:hide();
end

function Lua_VipUpTipsWindow:dispose()
	if self.showVipContainer ~= nil then
		self.showVipContainer:dispose();
		self.showVipContainer = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_VipPrivilegeDesItem = class("Lua_VipPrivilegeDesItem", Lua_DragContainerItem);
function Lua_VipPrivilegeDesItem:ctor(p)
	self:superCall("ctor", p, "VipUpTipsItem_skin");
end

function Lua_VipPrivilegeDesItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_VipPrivilegeDesItem:setData(data)
	if data == nil then
		return;
	end

	local startIdx, endIdx = string.find(data, "〖", 1);
	local des = string.gsub(data, "〖", "");
	if startIdx ~= nil then
		self.icon:setAltas("vip_atlas", "ui_vip_label_03");
		self.newLab:setLangValue(320009);
		self.desLab.text = LanUtil.formateStr(des, "83E490", "83E490");
	else
		self.icon:setAltas("vip_atlas", "ui_vip_label_05");
		self.newLab.text = "";
		self.desLab.text = LanUtil.formateStr(des, "F7EDCC", "F7EDCC");
	end
	self.icon:resetSize();
end

function Lua_VipPrivilegeDesItem:setCellSeqIndex(idx)
	self:superCall("setCellSeqIndex", idx);

	self.itemBg:setEnable(idx % 2 ~= 0);
end

function Lua_VipPrivilegeDesItem:getWidth()
	return 720;
end

function Lua_VipPrivilegeDesItem:getHeight()
	return self.itemBg.height;
end

function Lua_VipPrivilegeDesItem:dispose()
	self:superCall("dispose");
end










Lua_VipUpTipsSubItem = class("Lua_VipUpTipsSubItem", Lua_ItemIconCell);
function Lua_VipUpTipsSubItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_VipUpTipsSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon:setScale(0.75, 0.75);
end