-- 战令基类panel
checkRequire("Lua_WarOrderBtnItem");
checkRequire("Lua_WarOrderBaseItem");
Lua_WarOrderBasePanel = class("Lua_WarOrderBasePanel", Lua_DisplayObject);
function Lua_WarOrderBasePanel:ctor(p, skin)
	self:superCall("ctor", p, skin);
end

function Lua_WarOrderBasePanel:buildPanel()
	self:superCall("buildPanel");

	self:addLuaEvent("WAR_ORDER_INFO_UPDATE", self, self.updateInfo);
	self:addLuaEvent("WAR_ORDER_STEP_SELECT", self, self.updateStepSelect);
end

function Lua_WarOrderBasePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.btnList = Lua_DragList.new(self.content, 662, 52, Lua_AxisDefine.Horizontal);
	self.btnList:setListCell(Lua_WarOrderBtnItem, 140, 52, 1);
	self.btnList:setCellSpacing(10, 0);
	self.btnList:setRectAnchor(1);
	self.btnList:setRectPivot(3);
	self.btnList:setLocation(-331, -369, 0);

	self.rewardList = Lua_DragList.new(self.content, 677, 770 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.rewardList:setListCell(Lua_WarOrderBaseItem, 677, 118, 1);
	self.rewardList:setCellSpacing(0, 6);
	self.rewardList:setRectAnchor(1);
	self.rewardList:setLocation(0, -840 - self.adaptHeight / 2, 0);
	self.rewardList.tweenId = 2010;
	self.rewardList.delayTween = true;
end

function Lua_WarOrderBasePanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	local idx = self.toIndex == nil and 1 or self.toIndex;
	self.rewardList:setContentRect(677, 770 + self.adaptHeight);
	self.rewardList:setLocation(0, -840 - adaptHeight / 2, 0);
	self.rewardList:moveToIndex(self.toIndex, true);
end

function Lua_WarOrderBasePanel:setData(data)
	self.data = data;
	Lua_ProxyManager.getProxy("Lua_WarOrderProxy"):sWarOrderInfo(self.data.param);
end

function Lua_WarOrderBasePanel:updateInfo()
	if self.step == nil or  DataCenter.warOrderData:isExitReward(self.step) == false then
		self.step = DataCenter.warOrderData.getDefaultStep;
	end
	local arr = DataCenter.warOrderData.activeStepArr;
	self.btnList.canDrag = arr:getSize() > 4;
	self.btnList:setArrayData(arr);
	self.btnList:setSelected(self.step);

	self:updateShow();
end

function Lua_WarOrderBasePanel:updateShow()
	local rewardVoArr = DataCenter.warOrderData:getWarOrderVoArr(self.step, true);
	self.toIndex = DataCenter.warOrderData:getRewardIdx(self.step);
	self.rewardList:setArrayData(rewardVoArr);
	self.rewardList:moveToIndex(self.toIndex, true);
end

function Lua_WarOrderBasePanel:updateStepSelect(step)
	if self.step == nil or self.step == step then
		return;
	end
	self.step = step;
	self:updateShow();
end

function Lua_WarOrderBasePanel:onGoBtnClick(go)
	local funcPathId = DataCenter.warOrderUtil:getFuncPath(self.data.param);
	DataCenter.funcPathUtil:gotoFunction(funcPathId, true)
end

function Lua_WarOrderBasePanel:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end