-- 战令通用panel
checkRequire("Lua_WarOrderBasePanel");
Lua_WarOrderPanel = class("Lua_WarOrderPanel", Lua_WarOrderBasePanel);
function Lua_WarOrderPanel:ctor(p)
	self:superCall("ctor", p, "WarOrderPanel_skin");
end

function Lua_WarOrderPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.ruleBtn:addClickFuntion(self, self.onTipIconClick);
	self.goBtn:addClickFuntion(self, self.onGoBtnClick);
	self.unLockBtn:addClickFuntion(self, self.onUnLockBtnClick);
end

function Lua_WarOrderPanel:setData(data)
	self:superCall("setData", data);
	
	local lvBgInfo = DataCenter.warOrderUtil:getLvBgInfo(data.param);
	self.lvBg:setAltas(lvBgInfo[1], lvBgInfo[2]);
	self.lvBg:resetSize();
end

function Lua_WarOrderPanel:updateShow()
	self:superCall("updateShow");

	local warOrderData = DataCenter.warOrderData;
	local arr = warOrderData.activeStepArr;
	if self.data.param == Lua_WarOrderData.LightTower then
		self.lvTxt.text = "";
		self.tipTxt.text = LanUtil.formateStr(550000, warOrderData.curTarget);
		self.btnList:setEnable(true);
	end

	self.lockState = warOrderData:curAdvActState(self.step) == false; -- 未解锁
	if self.lockState then
		local rechargeId = DataCenter.warOrderUtil:getRechargeId(self.data.param, self.step);
		self.rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
		self.unLockBtn.label = LanUtil.formateStr(550001, self.rechargeInfo.money);
	else
		self.unLockBtn:setLangValue(550002); -- 已解锁
	end
	self.lockIcon:setEnable(self.lockState);
end

function Lua_WarOrderPanel:onTipIconClick(go)
	local tipsData = { des = nil, posX = 200, posY = -230 };
	if self.data.param == Lua_WarOrderData.LightTower then
		tipsData.des = LanUtil.getValue(550003);
	end
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_WarOrderPanel:onUnLockBtnClick(go)
	if self.step == nil then
		return;
	end

	if self.lockState == false then
		OperateAlert.showLangValue(570004);
		return;
	end
	Lua_WindowUtil.openWin("Lua_WarOrderBuyWindow", Lua_WinParam.ACTION_OPEN, self.step);
end

function Lua_WarOrderPanel:dispose()
	self:superCall("dispose");
end