-- 战令 普通奖励Item
Lua_WarOrderRewardItem = class("Lua_WarOrderRewardItem", Lua_ListCell);
function Lua_WarOrderRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_WarOrderRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.75, 0.75);
end

function Lua_WarOrderRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end
	
	self.itemIcon:setData(data);
	self.itemIcon:setDrawMask(data.state == 2, "investment_atlas", "xui_czjz_label_1");
	self:showRedDot(data.state == 1);
end

function Lua_WarOrderRewardItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(34, 34, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_WarOrderRewardItem:checkOnPress(winPosX, winPosY)
	local minX = self.posX - self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local maxX = self.posX + self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local minY = self.posY - self.itemIcon.itemH * self.itemIcon.scaleY / 2;
	local maxY = self.posY + self.itemIcon.itemH * self.itemIcon.scaleY / 2;
	if winPosX >= minX and winPosX <= maxX and winPosY >= minY and winPosY <= maxY then
		self:onPressClick();
	end
end

function Lua_WarOrderRewardItem:onPressClick()
	local step = DataCenter.warOrderUtil:getConfigInfo(self.data.index, "step");
	if self.data.unLock then
		local curType = DataCenter.warOrderData.curType;
		if self.data.state == 0 then
			if curType == Lua_WarOrderData.LightTower then
				OperateAlert.showLangValue(550006);
			elseif curType == Lua_WarOrderData.Expedition then
				OperateAlert.showLangValue(560006);
			elseif curType == Lua_WarOrderData.PeakDuel then
				OperateAlert.showLangValue(580006);
			elseif curType == Lua_WarOrderData.EquipCopyWarMakes then
				OperateAlert.showLangValue(590006);
			elseif curType == Lua_WarOrderData.KunXuHolyLandWarMakes then
				OperateAlert.showLangValue(600006);
			end
			DataCenter.packUtil:showItemInfo(self.data);
		elseif self.data.state == 1 then
			Lua_ProxyManager.getProxy("Lua_WarOrderProxy"):sWarOrderReward(curType, step);
		elseif self.data.state == 2 then
			DataCenter.packUtil:showItemInfo(self.data);
		end
	else
		Lua_WindowUtil.openWin("Lua_WarOrderBuyWindow", Lua_WinParam.ACTION_OPEN, step);
	end
end

function Lua_WarOrderRewardItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end