-- 寂灭岛战令
checkRequire("Lua_WarOrderBasePanel");
Lua_EquipCopyWarMakesPanel = class("Lua_EquipCopyWarMakesPanel", Lua_WarOrderBasePanel);
function Lua_EquipCopyWarMakesPanel:ctor(p)
	self:superCall("ctor", p, "EquipCopyWarMakesPanel_skin");
end

function Lua_EquipCopyWarMakesPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.markProgressBar:setValue(0);
	self.btnList:setEnable(false);
	self.tipTxt:setLangValue(590000);

	self.ruleBtn:addClickFuntion(self, self.onTipIconClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	self.goBtn:addClickFuntion(self, self.onGoBtnClick);
	self.dayRewardBtn:addClickFuntion(self, self.onDayRewardBtnClick);
	self.unLockBtn:addClickFuntion(self, self.onUnLockBtnClick);
end

function Lua_EquipCopyWarMakesPanel:updateShow()
	self:superCall("updateShow");
	
	local curLevelVo = DataCenter.warOrderData.getCurWarOrderVo;
	local maxLevelVo = DataCenter.warOrderData.getMaxWarOrderVo;
	self.lvTxt.text = curLevelVo.show_cond;

	local maxValue;
	local curValue;
	if curLevelVo.show_cond == maxLevelVo.show_cond then
		maxValue = maxLevelVo.cond_value;
		curValue = maxValue;
	else
		maxValue = curLevelVo.cond_value;
		curValue = DataCenter.warOrderData.curTarget;
	end
	self.markProgressBar:setMaxValue(maxValue);
	self.markProgressBar:setValue(curValue);
	self.markProgressBar:setText(curValue.."/"..maxValue);

	self.lockState = DataCenter.warOrderData:curAdvActState(self.step) == false; -- 未解锁
	if self.lockState then
		local rechargeId = DataCenter.warOrderUtil:getRechargeId(self.data.param, self.step);
		self.rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
		self.unLockBtn.label = LanUtil.formateStr(590001, self.rechargeInfo.money);
	else
		self.unLockBtn:setLangValue(590002);
	end
	self.lockIcon:setEnable(self.lockState);

	local state = DataCenter.warOrderData.dayRewardState;
	local spriteName = state == 2 and "ui_djc_box_003_p" or "ui_djc_box_003_n";
	self.dayRewardBtn:setAltas("common_altas_4", spriteName);
	self.dayRewardBtn:resetSize();
	self.canDrwaIcon:setEnable(state == 1);
	
	self:startTimer();
	self:onTimer();
end

function Lua_EquipCopyWarMakesPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		Lua_CommonUtil.addTimer("Lua_EquipCopyWarMakesPanel", 1, self, self.onTimer);
	end
end

function Lua_EquipCopyWarMakesPanel:onTimer()
	local time = DataCenter.warOrderData.warOrderEndTick - DataCenter.roleData.serverTime;
	if time > 0 then
		self.timeTxt.text = LanUtil.formateStr(590007, Lua_TimeTransform.transSeconds18(time, true, true, true, false));            
	else
		self.timeTxt.text = "";
		self:endTimer();
	end
end

function Lua_EquipCopyWarMakesPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onTimer);
	end
end

function Lua_EquipCopyWarMakesPanel:onTipIconClick(go)
	local tipsData = { des = LanUtil.getValue(590003), posX = 200, posY = -230 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_EquipCopyWarMakesPanel:onAddBtnClick(go)
	local info = DataCenter.warOrderUtil:getInfoByType(self.data.param);
	local time = DataCenter.warOrderData.warOrderEndTick - DataCenter.roleData.serverTime;
	if time > info.can_buy_day * 86400 then
		OperateAlert.show(LanUtil.formateStr(590008, info.can_buy_day));
	else
		if DataCenter.warOrderData.isMaxLevel == false then -- 可购买
			Lua_WindowUtil.openWin("Lua_WarOrderBuyExpWindow", Lua_WinParam.ACTION_OPEN, {
				curType = self.data.param,
				step = self.step,
				isLock = self.lockState
			});
		else
			OperateAlert.showLangValue(590009);
		end
	end
end

function Lua_EquipCopyWarMakesPanel:onDayRewardBtnClick(go)
	if self.lockState then -- 未解锁
		OperateAlert.showLangValue(590010);
	else
		if DataCenter.warOrderData.dayRewardState == 1 then -- 可领取
			Lua_ProxyManager.getProxy("Lua_WarOrderProxy"):sWarOrderReward(self.data.param, 0);
		else
			OperateAlert.showLangValue(590011);
		end
	end
end

function Lua_EquipCopyWarMakesPanel:onUnLockBtnClick(go)
	if self.step == nil then
		return;
	end

	if self.lockState == false then
		OperateAlert.showLangValue(590004);
		return;
	end
	Lua_WindowUtil.openWin("Lua_WarOrderBuyWindow", Lua_WinParam.ACTION_OPEN, self.step);
end

function Lua_EquipCopyWarMakesPanel:dispose()
	self:endTimer();
	self:superCall("dispose");
end