-- 昆墟圣地战令
checkRequire("Lua_WarOrderBasePanel");
Lua_KunXunHolyLandWarMakesPanel = class("Lua_KunXunHolyLandWarMakesPanel", Lua_WarOrderBasePanel);
function Lua_KunXunHolyLandWarMakesPanel:ctor(p)
	self:superCall("ctor", p, "KunXuWarMakesPanel_skin");
end

function Lua_KunXunHolyLandWarMakesPanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self.markProgressBar:setValue(0);
	self.btnList:setEnable(false);
	self.tipTxt:setLangValue(600000);
	
	self.ruleBtn:addClickFuntion(self, self.onTipIconClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	self.goBtn:addClickFuntion(self, self.onGoBtnClick);
	self.unLockBtn:addClickFuntion(self, self.onUnLockBtnClick);
end

function Lua_KunXunHolyLandWarMakesPanel:updateShow()
	self:superCall("updateShow");

	local curLevelVo = DataCenter.warOrderData.getCurWarOrderVo;
	local maxLevelVo = DataCenter.warOrderData.getMaxWarOrderVo;
	self.lvTxt.text = curLevelVo.show_cond;

	local maxValue;
	local curValue;
	if curLevelVo.show_cond == maxLevelVo.show_cond then
		maxValue = maxLevelVo.cond_value;
		curValue = maxValue;
	else
		maxValue = curLevelVo.cond_value;
		curValue = DataCenter.warOrderData.curTarget;
	end
	self.markProgressBar:setMaxValue(maxValue);
	self.markProgressBar:setValue(curValue);
	self.markProgressBar:setText(curValue.."/"..maxValue);

	self.lockState = DataCenter.warOrderData:curAdvActState(self.step) == false; -- 未解锁
	if self.lockState then
		local rechargeId = DataCenter.warOrderUtil:getRechargeId(self.data.param, self.step);
		self.rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
		self.unLockBtn.label = LanUtil.formateStr(600001, self.rechargeInfo.money);
	else
		self.unLockBtn:setLangValue(600002);
	end
	self.lockIcon:setEnable(self.lockState);

	self:startTimer();
	self:onTimer();
end

function Lua_KunXunHolyLandWarMakesPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		Lua_CommonUtil.addTimer("Lua_KunXunHolyLandWarMakesPanel", 1, self, self.onTimer);
	end
end

function Lua_KunXunHolyLandWarMakesPanel:onTimer()
	local time = DataCenter.warOrderData.warOrderEndTick - DataCenter.roleData.serverTime;
	if time > 0 then
		self.timeTxt:setEnable(true);
		self.timeTxt.text = LanUtil.formateStr(600007, Lua_TimeTransform.transSeconds18(time, true, true, true, false));            
	else
		self.timeTxt:setEnable(false);
		self:endTimer();
	end
end

function Lua_KunXunHolyLandWarMakesPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onTimer);
	end
end

function Lua_KunXunHolyLandWarMakesPanel:onTipIconClick()
	local tipsData = { des = LanUtil.getValue(600003), posX = 200, posY = -230 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_KunXunHolyLandWarMakesPanel:onAddBtnClick(go)
	local info = DataCenter.warOrderUtil:getInfoByType(self.data.param);
	local time = DataCenter.warOrderData.warOrderEndTick - DataCenter.roleData.serverTime;
	if time > info.can_buy_day * 86400 then
		OperateAlert.show(LanUtil.formateStr(600008, info.can_buy_day));
	else
		if DataCenter.warOrderData.isMaxLevel == false then -- 可购买
			Lua_WindowUtil.openWin("Lua_WarOrderBuyExpWindow", Lua_WinParam.ACTION_OPEN, {
				curType = self.data.param,
				step = self.step,
				isLock = self.lockState
			});
		else
			OperateAlert.showLangValue(600009);
		end
	end
end

function Lua_KunXunHolyLandWarMakesPanel:onUnLockBtnClick(go)
	if self.step == nil then
		return;
	end

	if self.lockState == false then
		OperateAlert.showLangValue(600004);
		return;
	end
	Lua_WindowUtil.openWin("Lua_WarOrderBuyWindow", Lua_WinParam.ACTION_OPEN, self.step);
end

function Lua_KunXunHolyLandWarMakesPanel:dispose()
	self:endTimer();
	self:superCall("dispose");
end